Index: /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/DbTestApp.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/DbTestApp.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/DbTestApp.cs	(revision 3931)
@@ -1,3 +1,4 @@
 ﻿#region License Information
+
 /* HeuristicLab
  * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
@@ -18,4 +19,5 @@
  * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
  */
+
 #endregion
 
@@ -37,8 +39,10 @@
 using HeuristicLab.Hive.Server.LINQDataAccess;
 using System.Transactions;
+using System.Threading;
+using HeuristicLab.Tracing;
 
 namespace HeuristicLab.Hive.Server {
   [Application("Hive DB Test App", "Test Application for the Hive DataAccess Layer")]
-  class HiveDbTestApplication : ApplicationBase {
+  internal class HiveDbTestApplication : ApplicationBase {
     /*private void TestJobStreaming() {
       ISessionFactory factory =
@@ -111,10 +115,8 @@
     } */
 
-    ClientDao clientDao = new ClientDao();
-    ClientGroupDao cgd = new ClientGroupDao();
-
-    private void TestLINQImplementation() {      
-      
-      
+    private ClientDao clientDao = new ClientDao();
+    private ClientGroupDao cgd = new ClientGroupDao();
+
+    private void TestLINQImplementation() {
       ClientDto c1 = new ClientDto();
       c1.Id = Guid.NewGuid();
@@ -143,7 +145,4 @@
       c2 = clientDao.Insert(c2);
 
-      //ClientDto info2 = clientDao.FindById(info.Id);
-      //Console.WriteLine(info2);
-      
       ClientGroupDto tg = new ClientGroupDto();
       tg.Name = "TopGroup";
@@ -174,5 +173,5 @@
 
       List<ClientGroupDto> list = new List<ClientGroupDto>(cgd.FindAllWithSubGroupsAndClients());
-      
+
       cgd.RemoveRessourceFromClientGroup(sg.Id, tg.Id);
 
@@ -181,5 +180,4 @@
       clientDao.Delete(c1);
       clientDao.Delete(c2);
-
     }
 
@@ -220,10 +218,7 @@
         sg = cgd.Insert(sg);
         cgd.AddRessourceToClientGroup(sg.Id, mg.Id);
-        populateMainGroup(sg, p-1);
-      }
-
-      
-    }
-
+        populateMainGroup(sg, p - 1);
+      }
+    }
 
 
@@ -235,29 +230,115 @@
       //TestJobResultDeserialization();
 
+      //if (ContextFactory.Context.DatabaseExists())
+      //  ContextFactory.Context.DeleteDatabase();
+      //ContextFactory.Context.CreateDatabase();
       //TestLINQImplementation();
+      TestLinqFileHandling();
       //StressTest();
 
       //SpeedTest();
       //TestJobBytearrFetching();
-      TestJobStreamFetching();
-
-    }
-
-    private void TestJobStreamFetching() {
+      //TestJobStreamFetching();
+    }
+
+    private void WriteToJobWithByte(object jobid) {
+      using (TransactionScope scope = new TransactionScope(TransactionScopeOption.Required,
+                                                           new TransactionOptions
+                                                           {IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE})
+        ) {
+        Logger.Info("starting bytestuff for job " + jobid);
+        DaoLocator.JobDao.SetBinaryJobFile((Guid)jobid, jobmap[(Guid)jobid]);
+        scope.Complete();
+        Logger.Info("ended bytestuff for job " + jobid);
+      }
+    }
+
+    private void UpdateJobStatus(object jobid) {
+      using (TransactionScope scope = new TransactionScope(TransactionScopeOption.Required,
+                                                           new TransactionOptions
+                                                           {IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE})
+        ) {
+        Thread.Sleep(1500);
+        Logger.Info("starting now");
+        JobDto job = DaoLocator.JobDao.FindById((Guid)jobid);
+        job.Percentage = new Random().NextDouble();
+        DaoLocator.JobDao.Update(job);
+        scope.Complete();
+        Logger.Info("ended");
+      }
+    }
+
+    Dictionary<Guid, byte[]> jobmap = new Dictionary<Guid, byte[]>();
+
+
+    private void TestLinqFileHandling() {
+      List<Thread> jobupdateThreads = new List<Thread>();
+      List<Thread> jobProgressThreads = new List<Thread>();
+      
+      Random r = new Random();
+      Stack<JobDto> jobs = new Stack<JobDto>(DaoLocator.JobDao.FindAll());
+      Logger.Info("Fetched jobs");
+      for (int x = 0; x < 10 && jobs.Count > 0; x++ ) {
+        Logger.Info("Creating data for Job");
+        JobDto job = jobs.Pop();
+        byte[] jobarr = new byte[50*1024*1024];
+        for (int i = 0; i < jobarr.Length; i++) {
+          jobarr[i] = (byte) r.Next(255);
+        }
+        jobmap.Add(job.Id, jobarr);
+      }
+      Logger.Info("filled");
+      foreach(KeyValuePair<Guid, byte[]> kvp in jobmap) {
+        Thread tjob = new Thread(new ParameterizedThreadStart(WriteToJobWithByte));      
+        Thread tupdate = new Thread(new ParameterizedThreadStart(UpdateJobStatus));
+        jobupdateThreads.Add(tupdate);
+        jobProgressThreads.Add(tjob);
+        tupdate.Start(kvp.Key);
+        tjob.Start(kvp.Key);
+      }
+      foreach (Thread t in jobupdateThreads) {
+        t.Join();
+      }
+      foreach (Thread t in jobProgressThreads) {
+        t.Join();
+      }
+    }
+
+
+    private
+      void TestJobStreamFetching() {
       //using (TransactionScope scope = new TransactionScope()) {
+
       HiveDataContext context = ContextFactory.Context;
 
-      ContextFactory.Context.Connection.Open();
-      ContextFactory.Context.Transaction = ContextFactory.Context.Connection.BeginTransaction();
-      
+      ContextFactory.Context.Connection.Open
+        ();
+      ContextFactory.Context.Transaction
+        =
+        ContextFactory.Context.Connection.BeginTransaction
+          ();
+
+
       ClientFacade facade = new ClientFacade();
+
       Stream stream = facade.SendStreamedJob(new Guid("F5CFB334-66A0-417C-A585-71711BA21D3F"));
-      
+
+
       byte[] buffer = new byte[3024];
+
       int read = 0;
-      
-      while ((read = stream.Read(buffer, 0, buffer.Length)) > 0) {}
-      
-      stream.Close();
+
+      while ((
+               read
+               =
+               stream.Read
+                 (
+                 buffer
+                 , 0,
+                 buffer.Length
+                 )) > 0) {}
+
+      stream.Close
+        ();
 
       //Stream stream = DaoLocator.JobDao.GetSerializedJobStream(new Guid("bbb51f87-4e2f-4499-a9b6-884e589c78b6"));
@@ -265,18 +346,27 @@
     }
 
-    private void TestJobBytearrFetching() {
+    private
+      void TestJobBytearrFetching() {
       byte[] arr = DaoLocator.JobDao.GetBinaryJobFile(new Guid("A3386907-2B3C-4976-BE07-04D660D40A5B"));
-      Console.WriteLine(arr);
-    }
-
-    private void SpeedTest() {
+      Console.WriteLine
+        (
+        arr
+        );
+    }
+
+    private
+      void SpeedTest() {
       DateTime start = new DateTime();
+
       List<ClientGroupDto> list = new List<ClientGroupDto>(cgd.FindAllWithSubGroupsAndClients());
+
       DateTime end = new DateTime();
+
       TimeSpan used = end - start;
-      Console.WriteLine(used.TotalMilliseconds);
-    }
-
-
+      Console.WriteLine
+        (
+        used.TotalMilliseconds
+        );
+    }
   }
 }
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/InternalInterfaces/IInternalJobManager.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/InternalInterfaces/IInternalJobManager.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/InternalInterfaces/IInternalJobManager.cs	(revision 3931)
@@ -28,8 +28,8 @@
 
 namespace HeuristicLab.Hive.Server.Core.InternalInterfaces {
-  interface IInternalJobManager {
-    void ResetJobsDependingOnResults(JobDto job);
-
+  interface IInternalJobManager {   
     Stream GetJobStreamById(Guid jobId);
+    byte[] GetSerializedJobDataById(Guid jobId);
+    void SetSerializedJobDataById(Guid jobId, byte[] data);
   }
 }
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/JobManager.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/JobManager.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.Core/3.2/JobManager.cs	(revision 3931)
@@ -1,3 +1,4 @@
 ﻿#region License Information
+
 /* HeuristicLab
  * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
@@ -18,4 +19,5 @@
  * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
  */
+
 #endregion
 
@@ -38,8 +40,7 @@
 
 namespace HeuristicLab.Hive.Server.Core {
-  class JobManager: IJobManager, IInternalJobManager {
-
+  internal class JobManager : IJobManager, IInternalJobManager {
     //ISessionFactory factory;
-    ILifecycleManager lifecycleManager;
+    private ILifecycleManager lifecycleManager;
 
     #region IJobManager Members
@@ -53,23 +54,19 @@
     }
 
-    private JobDto GetLastJobResult(Guid jobId) {     
+    private JobDto GetLastJobResult(Guid jobId) {
       return DaoLocator.JobDao.FindById(jobId);
     }
 
-    public void ResetJobsDependingOnResults(JobDto job) {
-      Logger.Info("Setting job " + job.Id + " offline");
-      if (job != null) {
-        DaoLocator.JobDao.SetJobOffline(job);
-      }
-    }
-         
-
-    void checkForDeadJobs() {
+
+    private void checkForDeadJobs() {
       Logger.Info("Searching for dead Jobs");
-      using (TransactionScope scope = new TransactionScope(TransactionScopeOption.Required, new TransactionOptions { IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE })) {
+      using (
+        TransactionScope scope = new TransactionScope(TransactionScopeOption.Required,
+                                                      new TransactionOptions
+                                                      {IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE})) {
         List<JobDto> allJobs = new List<JobDto>(DaoLocator.JobDao.FindAll());
         foreach (JobDto curJob in allJobs) {
-          if (curJob.State != State.calculating) {
-            ResetJobsDependingOnResults(curJob);
+          if (curJob.State != State.calculating && curJob.State != State.finished) {
+            DaoLocator.JobDao.SetJobOffline(curJob);
           }
         }
@@ -79,10 +76,14 @@
     }
 
-    void lifecycleManager_OnStartup(object sender, EventArgs e) {
+    private void lifecycleManager_OnStartup(object sender, EventArgs e) {
+      Logger.Info("Startup Event Fired, Checking DB for consistency");
       checkForDeadJobs();
-    }
-
-    void lifecycleManager_OnShutdown(object sender, EventArgs e) {
+      Logger.Info("Startup Event Done");
+    }
+
+    private void lifecycleManager_OnShutdown(object sender, EventArgs e) {
+      Logger.Info("Startup Event Fired, Checking DB for consistency");
       checkForDeadJobs();
+      Logger.Info("Startup Event Done");
     }
 
@@ -92,11 +93,11 @@
     /// <returns></returns>
     public ResponseList<JobDto> GetAllJobs() {
-         ResponseList<JobDto> response = new ResponseList<JobDto>();
-
-         response.List = new List<JobDto>(DaoLocator.JobDao.FindAll());
-         response.Success = true;
-         response.StatusMessage = ApplicationConstants.RESPONSE_JOB_ALL_JOBS;
-
-         return response;
+      ResponseList<JobDto> response = new ResponseList<JobDto>();
+
+      response.List = new List<JobDto>(DaoLocator.JobDao.FindAll());
+      response.Success = true;
+      response.StatusMessage = ApplicationConstants.RESPONSE_JOB_ALL_JOBS;
+
+      return response;
     }
 
@@ -105,5 +106,5 @@
       response.List = new List<JobDto>(DaoLocator.JobDao.FindWithLimitations(jobState, offset, count));
       return response;
-    }  
+    }
 
     /// <summary>
@@ -112,7 +113,6 @@
     /// <param name="jobId"></param>
     /// <returns></returns>
-    public Stream GetJobStreamById(Guid jobId) {           
+    public Stream GetJobStreamById(Guid jobId) {
       return DaoLocator.JobDao.GetSerializedJobStream(jobId);
-      
     }
 
@@ -122,17 +122,18 @@
     /// <returns></returns>
     public ResponseObject<JobDto> GetJobById(Guid jobId) {
-        ResponseObject<JobDto> response = new ResponseObject<JobDto>();
+      ResponseObject<JobDto> response = new ResponseObject<JobDto>();
 
       response.Obj = DaoLocator.JobDao.FindById(jobId);
-        if (response.Obj != null) {
-          response.Success = true;
-          response.StatusMessage = ApplicationConstants.RESPONSE_JOB_GET_JOB_BY_ID;
-        } else {
-          response.Success = false;
-          response.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOB_DOESNT_EXIST;
-        }
-
-        return response;
-      }
+      if (response.Obj != null) {
+        response.Success = true;
+        response.StatusMessage = ApplicationConstants.RESPONSE_JOB_GET_JOB_BY_ID;
+      }
+      else {
+        response.Success = false;
+        response.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOB_DOESNT_EXIST;
+      }
+
+      return response;
+    }
 
     public ResponseObject<JobDto> GetJobByIdWithDetails(Guid jobId) {
@@ -144,8 +145,9 @@
 
         job.Obj.Client = DaoLocator.ClientDao.GetClientForJob(jobId);
-      } else {
+      }
+      else {
         job.Success = false;
         job.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOB_DOESNT_EXIST;
-      }      
+      }
       return job;
     }
@@ -154,5 +156,5 @@
       IClientGroupDao cgd = DaoLocator.ClientGroupDao;
       foreach (string res in resources) {
-        foreach(ClientGroupDto cg in cgd.FindByName(res)) {
+        foreach (ClientGroupDto cg in cgd.FindByName(res)) {
           job.JobInfo.AssignedResourceIds.Add(cg.Id);
         }
@@ -167,63 +169,59 @@
     /// <returns></returns>
     public ResponseObject<JobDto> AddNewJob(SerializedJob job) {
-        ResponseObject<JobDto> response = new ResponseObject<JobDto>();
-
-        if (job != null && job.JobInfo != null) {
-          if (job.JobInfo.State != State.offline) {
-            response.Success = false;
-            response.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOBSTATE_MUST_BE_OFFLINE;
-            return response;
-          }
-          if (job.JobInfo.Id != Guid.Empty) {
-            response.Success = false;
-            response.StatusMessage = ApplicationConstants.RESPONSE_JOB_ID_MUST_NOT_BE_SET;
-            return response;
-          }
-          if (job.SerializedJobData == null) {
-            response.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOB_NULL;
-            response.Success = false;
-            return response;
-          }
-
-          job.JobInfo.DateCreated = DateTime.Now;
-          DaoLocator.JobDao.InsertWithAttachedJob(job);
-          DaoLocator.PluginInfoDao.InsertPluginDependenciesForJob(job.JobInfo);
-          
-          response.Success = true;
-          response.Obj = job.JobInfo;
-          response.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOB_ADDED;
-        } else {
+      ResponseObject<JobDto> response = new ResponseObject<JobDto>();
+
+      if (job != null && job.JobInfo != null) {
+        if (job.JobInfo.State != State.offline) {
           response.Success = false;
+          response.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOBSTATE_MUST_BE_OFFLINE;
+          return response;
+        }
+        if (job.JobInfo.Id != Guid.Empty) {
+          response.Success = false;
+          response.StatusMessage = ApplicationConstants.RESPONSE_JOB_ID_MUST_NOT_BE_SET;
+          return response;
+        }
+        if (job.SerializedJobData == null) {
           response.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOB_NULL;
-        }
-
+          response.Success = false;
+          return response;
+        }
+
+        job.JobInfo.DateCreated = DateTime.Now;
+        DaoLocator.JobDao.InsertWithAttachedJob(job);
+        DaoLocator.PluginInfoDao.InsertPluginDependenciesForJob(job.JobInfo);
+
+        response.Success = true;
+        response.Obj = job.JobInfo;
+        response.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOB_ADDED;
+      }
+      else {
+        response.Success = false;
+        response.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOB_NULL;
+      }
+
+      return response;
+    }
+
+    /// <summary>
+    /// Removes a job from the database
+    /// </summary>
+    /// <param name="jobId"></param>
+    /// <returns></returns>
+    public Response RemoveJob(Guid jobId) {
+      Response response = new Response();
+
+      JobDto job = DaoLocator.JobDao.FindById(jobId);
+      if (job == null) {
+        response.Success = false;
+        response.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOB_DOESNT_EXIST;
         return response;
       }
-    /*  finally {
-        if (session != null)
-          session.EndSession();
-      }
-    } */
-
-    /// <summary>
-    /// Removes a job from the database
-    /// </summary>
-    /// <param name="jobId"></param>
-    /// <returns></returns>
-    public Response RemoveJob(Guid jobId) {
-        Response response = new Response();
-
-      JobDto job = DaoLocator.JobDao.FindById(jobId);
-        if (job == null) {
-          response.Success = false;
-          response.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOB_DOESNT_EXIST;
-          return response;
-        }
-        DaoLocator.JobDao.Delete(job);
-        response.Success = false;
-        response.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOB_REMOVED;
-
-        return response;
-      }
+      DaoLocator.JobDao.Delete(job);
+      response.Success = false;
+      response.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOB_REMOVED;
+
+      return response;
+    }
 
     public ResponseObject<JobDto> GetLastJobResultOf(Guid jobId) {
@@ -231,128 +229,88 @@
         new ResponseObject<JobDto>();
 
-       result.Obj =
-         GetLastJobResult(jobId);
-       result.Success =
-         result.Obj != null;
-
-       return result;
+      result.Obj =
+        GetLastJobResult(jobId);
+      result.Success =
+        result.Obj != null;
+
+      return result;
     }
 
     public ResponseObject<SerializedJob>
       GetLastSerializedJobResultOf(Guid jobId, bool requested) {
-
-        ResponseObject<SerializedJob> response =
-          new ResponseObject<SerializedJob>();
+      ResponseObject<SerializedJob> response =
+        new ResponseObject<SerializedJob>();
 
       JobDto job = DaoLocator.JobDao.FindById(jobId);
-        if (requested && (job.State == State.requestSnapshot || job.State == State.requestSnapshotSent)) {
-          response.Success = true;
-          response.StatusMessage = ApplicationConstants.RESPONSE_JOB_RESULT_NOT_YET_HERE;
-          
-          //tx.Commit();
-          
-          return response;
-        }
-
-        /*JobResult lastResult =
-          jobResultsAdapter.GetLastResultOf(job.Id);*/
-
-        //if (lastResult != null) {
-          response.Success = true;
-          response.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOB_RESULT_SENT;
-          response.Obj = new SerializedJob();
-          response.Obj.JobInfo = job;
-          response.Obj.SerializedJobData =
-            DaoLocator.JobDao.GetBinaryJobFile(jobId);
-        //} else {
-        //  response.Success = false;
-        //}
-
-        //tx.Commit();
+      if (requested && (job.State == State.requestSnapshot || job.State == State.requestSnapshotSent)) {
+        response.Success = true;
+        response.StatusMessage = ApplicationConstants.RESPONSE_JOB_RESULT_NOT_YET_HERE;
+
         return response;
       }
-      /*catch (Exception ex) {
-        if (tx != null)
-          tx.Rollback();
-        throw ex;
-      }
-      finally {
-        if (session != null)
-          session.EndSession();
-      }
-    }    */
+
+      response.Success = true;
+      response.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOB_RESULT_SENT;
+      response.Obj = new SerializedJob();
+      response.Obj.JobInfo = job;
+      response.Obj.SerializedJobData =
+        DaoLocator.JobDao.GetBinaryJobFile(jobId);
+      return response;
+    }
 
 
     public Response RequestSnapshot(Guid jobId) {
-     // ISession session = factory.GetSessionForCurrentThread();
       Response response = new Response();
-      
-     /* try {
-        IJobAdapter jobAdapter = session.GetDataAdapter<JobDto, IJobAdapter>();*/
-
-        JobDto job = DaoLocator.JobDao.FindById(jobId);
-        if (job.State == State.requestSnapshot || job.State == State.requestSnapshotSent) {
-          response.Success = true;
-          response.StatusMessage = ApplicationConstants.RESPONSE_JOB_REQUEST_ALLREADY_SET;
-          return response; // no commit needed
-        }
-        if (job.State != State.calculating) {
-          response.Success = false;
-          response.StatusMessage = ApplicationConstants.RESPONSE_JOB_IS_NOT_BEEING_CALCULATED;
-          return response; // no commit needed
-        }
-        // job is in correct state
-        job.State = State.requestSnapshot;
-        DaoLocator.JobDao.Update(job);
-
-        response.Success = true;
-        response.StatusMessage = ApplicationConstants.RESPONSE_JOB_REQUEST_SET;
-
+
+
+      JobDto job = DaoLocator.JobDao.FindById(jobId);
+      if (job.State == State.requestSnapshot || job.State == State.requestSnapshotSent) {
+        response.Success = true;
+        response.StatusMessage = ApplicationConstants.RESPONSE_JOB_REQUEST_ALLREADY_SET;
         return response;
       }
-    /*  finally {
-        if (session != null)
-          session.EndSession();
-      }
-    } */
+      if (job.State != State.calculating) {
+        response.Success = false;
+        response.StatusMessage = ApplicationConstants.RESPONSE_JOB_IS_NOT_BEEING_CALCULATED;
+        return response;
+      }
+      // job is in correct state
+      job.State = State.requestSnapshot;
+      DaoLocator.JobDao.Update(job);
+
+      response.Success = true;
+      response.StatusMessage = ApplicationConstants.RESPONSE_JOB_REQUEST_SET;
+
+      return response;
+    }
 
     public Response AbortJob(Guid jobId) {
-      //ISession session = factory.GetSessionForCurrentThread();
       Response response = new Response();
 
-    /*  try {
-        IJobAdapter jobAdapter = session.GetDataAdapter<JobDto, IJobAdapter>();*/
-
-//        JobDto job = jobAdapter.GetById(jobId);
       JobDto job = DaoLocator.JobDao.FindById(jobId);
-        if (job == null) {
-          response.Success = false;
-          response.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOB_DOESNT_EXIST;
-          return response; // no commit needed
-        }
-        if (job.State == State.abort) {
-          response.Success = true;
-          response.StatusMessage = ApplicationConstants.RESPONSE_JOB_ABORT_REQUEST_ALLREADY_SET;
-          return response; // no commit needed
-        }
-        if (job.State != State.calculating && job.State != State.requestSnapshot && job.State != State.requestSnapshotSent) {
-          response.Success = false;
-          response.StatusMessage = ApplicationConstants.RESPONSE_JOB_IS_NOT_BEEING_CALCULATED;
-          return response; // no commit needed
-        }
-        // job is in correct state
-        job.State = State.abort;
+      if (job == null) {
+        response.Success = false;
+        response.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOB_DOESNT_EXIST;
+        return response; // no commit needed
+      }
+      if (job.State == State.abort) {
+        response.Success = true;
+        response.StatusMessage = ApplicationConstants.RESPONSE_JOB_ABORT_REQUEST_ALLREADY_SET;
+        return response; // no commit needed
+      }
+      if (job.State != State.calculating && job.State != State.requestSnapshot && job.State != State.requestSnapshotSent) {
+        response.Success = false;
+        response.StatusMessage = ApplicationConstants.RESPONSE_JOB_IS_NOT_BEEING_CALCULATED;
+        return response; // no commit needed
+      }
+      // job is in correct state
+      job.State = State.abort;
       DaoLocator.JobDao.Update(job);
 
-        response.Success = true;
-        response.StatusMessage = ApplicationConstants.RESPONSE_JOB_ABORT_REQUEST_SET;
-
-        return response;
-      }
-      /*finally {
-        if (session != null)
-          session.EndSession();
-      }
-    }   */
+      response.Success = true;
+      response.StatusMessage = ApplicationConstants.RESPONSE_JOB_ABORT_REQUEST_SET;
+
+      return response;
+    }
 
     public ResponseList<JobResult> GetAllJobResults(Guid jobId) {
@@ -381,6 +339,15 @@
 
     public ResponseList<JobDto> GetJobsByProject(Guid projectId) {
-      return null;      
-    }
+      return null;
+    }
+
+    public byte[] GetSerializedJobDataById(Guid jobId) {
+      return DaoLocator.JobDao.GetBinaryJobFile(jobId);
+    }
+
+    public void SetSerializedJobDataById(Guid jobId, byte[] data) {
+      DaoLocator.JobDao.SetBinaryJobFile(jobId, data);
+    }
+
     #endregion
   }
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IJobDao.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IJobDao.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IJobDao.cs	(revision 3931)
@@ -23,4 +23,6 @@
 
     IEnumerable<JobDto> FindWithLimitations(State jobState, int offset, int count);
+
+    void SetBinaryJobFile(Guid jobId, byte[] data);
   }
 }
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/BaseDao.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/BaseDao.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/BaseDao.cs	(revision 3931)
@@ -15,11 +15,20 @@
 
     protected void CommitChanges() {
+      //TODO: DoWhile
       try {
         Context.SubmitChanges(ConflictMode.ContinueOnConflict);
       } catch (ChangeConflictException e) {
         Logger.Warn("Concurrency Exception! " + e.Message);
-        foreach (ObjectChangeConflict conflict in Context.ChangeConflicts) {          
+        foreach (ObjectChangeConflict conflict in Context.ChangeConflicts) { 
+          Logger.Info("Conflicted: ");
+          foreach (MemberChangeConflict memberChangeConflict in conflict.MemberConflicts) {
+            Logger.Info("    Member in Conflict: " + memberChangeConflict.Member.Name);
+            Logger.Info("    Database Value: " + memberChangeConflict.DatabaseValue);
+            Logger.Info("    Original value: " + memberChangeConflict.OriginalValue);
+            Logger.Info("    Current value: " + memberChangeConflict.CurrentValue);              
+          }
           conflict.Resolve(RefreshMode.KeepChanges);
         }
+        Context.SubmitChanges(ConflictMode.FailOnFirstConflict);
       }
     }
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/ClientDao.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/ClientDao.cs	(revision 3930)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/ClientDao.cs	(revision 3931)
@@ -14,5 +14,5 @@
 
     public ClientDto FindById(Guid id) {
-      return (from client in Context.Clients
+      return (from client in Context.Resources.OfType<Client>()                         
               where client.ResourceId.Equals(id)
               select EntityToDto(client, null)
@@ -21,5 +21,5 @@
 
     public IEnumerable<ClientDto> FindAll() {
-      return (from client in Context.Clients
+      return (from client in Context.Resources.OfType<Client>()
               select
                 EntityToDto(client, null)
@@ -28,6 +28,6 @@
 
     public IEnumerable<ClientDto> FindAllClientsWithoutGroup() {
-      return (from client in Context.Clients
-              where client.Resource.ClientGroup_Resources.Count == 0
+      return (from client in Context.Resources.OfType<Client>()
+              where client.ClientGroup_Resources_Parents.Count == 0
               select EntityToDto(client, null)).ToList();
     }
@@ -40,5 +40,5 @@
 
     public void SetServerSideCalendar(ClientDto client, Guid clientGroupId) {
-      Client dbclient = Context.Clients.SingleOrDefault(c => c.ResourceId.Equals(client.Id));
+      Client dbclient = Context.Resources.OfType<Client>().SingleOrDefault(c => c.ResourceId.Equals(client.Id));
       dbclient.UseCalendarFromResourceId = clientGroupId;
       dbclient.CalendarSyncStatus = Enum.GetName(typeof(CalendarState), CalendarState.Fetch);
@@ -48,5 +48,5 @@
     public ClientDto Insert(ClientDto info) {
       Client c = DtoToEntity(info, null);      
-      Context.Clients.InsertOnSubmit(c);
+      Context.Resources.InsertOnSubmit(c);
       CommitChanges();
       info.Id = c.ResourceId;
@@ -62,5 +62,5 @@
 
     public void Update(ClientDto info) {
-      Client client = Context.Clients.SingleOrDefault(c => c.ResourceId.Equals(info.Id));
+      Client client = Context.Resources.OfType<Client>().SingleOrDefault(c => c.ResourceId.Equals(info.Id));
       DtoToEntity(info, client);
       CommitChanges();      
@@ -75,10 +75,7 @@
       target.CPUSpeed = source.CpuSpeedPerCore;
       
-      if(target.Resource == null)
-        target.Resource = new Resource();
-
       target.FreeMemory = source.FreeMemory;
-      target.Resource.Name = source.Name;
-      target.Resource.ResourceId = source.Id;
+      target.Name = source.Name;
+      target.ResourceId = source.Id;
       target.CalendarSyncStatus = Enum.GetName(typeof(CalendarState), source.CalendarSyncStatus);
       target.Login = source.Login;
@@ -96,12 +93,12 @@
         target = new ClientDto();
       target.CpuSpeedPerCore = source.CPUSpeed;
-      target.FreeMemory = source.FreeMemory;
+      target.FreeMemory = source.FreeMemory ?? 0;
       target.Id = source.ResourceId;
       target.CalendarSyncStatus = (CalendarState) Enum.Parse(typeof (CalendarState), source.CalendarSyncStatus);
       target.Login = source.Login;
-      target.Memory = source.Memory;
-      target.Name = source.Resource.Name;
-      target.NrOfCores = source.NumberOfCores;
-      target.NrOfFreeCores = source.NumberOfFreeCores;
+      target.Memory = source.Memory ?? 0;
+      target.Name = source.Name;
+      target.NrOfCores = source.NumberOfCores ?? 0;
+      target.NrOfFreeCores = source.NumberOfFreeCores ?? 0;
       target.State = (State) Enum.Parse(typeof (State), source.Status);
       return target;
